/** 
 *  an interpreter for expressions
 */

package expression;

import java.io.*;
import expression.Tree.*;

/** interpreter visitor
 */
public class Interpreter implements Tree.Visitor, Tokens {
  
    /** the result value of interpretation
     */
    int val;

    /** construct a new interpreter
     */
    public Interpreter() {
    }
    
    /** the main interpretation method
     */
    public static int interpret(Tree tree) {
        Interpreter interp = new Interpreter();
	tree.apply(interp);
	return interp.val;
    }

    /** the visitor methods
     */     
    public void caseProgram(Program tree) {
	for (int i = 0; i < tree.defs.length; i ++) {
	    val = interpret(tree.defs[i]);
	}
    }
    
    public void caseDef(Def tree) {
	val = interpret(tree.expr);
    }
    
    public void caseIntLiteral(IntLiteral tree) {
	val = tree.i;
    }
        
    public void caseIdent(Ident tree) {
	val = 0;
    }
    
    public void caseBinOp(BinOp tree) {
	val = interpret(tree.left);
	switch (tree.op) {
	case '+': 
	    break;
	case '-': 
	    break;
	case '*': 
	    break;
	case '/': 
	    break;
	default:
	    Report.bug();
	}
    }

    public void caseBad(Bad tree) {
    }

}










