/*
 * scope for expressions
 */

package expression;

import java.io.*;
import java.util.*;

class Scope {

    /** map from identifier to symbol entries
     */
    public Map map;

    /** parent scope
     */
    public Scope outer;

    /** construct a new scope
     */
    public Scope(Scope outer) { 
	this.outer = outer;
	map = new HashMap();
    }
    
    /** enter a symbol in scope
     */
    public void enter(Symbol sym) {
	if (map.containsKey(sym.name)) {
	    Symbol other = (Symbol) map.get(sym.name);
	    Report.error(sym.pos, sym.name + " already defined at "
			 + Position.toString(other.pos));
	} else {
	    map.put(sym.name, sym);
	}
    }

    /** lookup a symbol
     */
    public Symbol lookup(String name) {
	if (map.containsKey(name)) {
	    return (Symbol)map.get(name);
	} else if (outer != null) {
	    return outer.lookup(name);
	} else {
	    return null;
	}
    }
}







